struct Day: Hashable {
	var name: String
	var dayType: DayType

	enum DayType {
		case working, holiday, resting
	}

	var hashValue: Int {
		return name.hashValue << 2 | dayType.hashValue
	}
}

let Mon = Day(name: "Monday", dayType: .working)
let Tue = Day(name: "Tuesday", dayType: .resting)
let Wed = Day(name: "Wednesday", dayType: .working)
let Thu = Day(name: "Thursday", dayType: .working)
let Fri = Day(name: "Friday", dayType: .working)
let Sat = Day(name: "Saturday", dayType: .holiday)
let Sun = Day(name: "Sunday", dayType: .holiday)

// This is a Dictionary
let weekDays = [Mon, Tue, Wed, Thu, Fri, Sat, Sun]
print(weekDays)

// Now you can group the values by DayType
let groupBy = Dictionary(grouping: weekDays,
				by: {item in item.dayType})
				
print(groupBy[.resting]!)
