protocol Computable {
    static func +(lhs: Self, rhs: Self) -> Self
    static func -(lhs: Self, rhs: Self) -> Self
}

func add<T: Computable>(_ num1: T, _ num2: T) -> T {
    return num1 + num2
}

func sub<T: Computable>(_ num1: T, _ num2: T) -> T {
    return num1 - num2
}

extension Int: Computable {}
extension Float: Computable {}
extension Double: Computable {}

print(add(3, 0.2), add(3, 2.2), sub(1.2, 2), sub(-3, 2))


func mySwap<T>(_ a: T, _ b: T) -> (T, T) {
	let tA = a
	let tB = b
	return (tB, tA)
}

print(mySwap(1, 2))
print(mySwap("Num 1", "Num 2"))