// Part 1
var days = ["Monday", "Tuesday", "Wednesday", 
	"Thursday", "Friday", "Saturday", "Sunday"]

// Before Swift 4: days[4..< days.endIndex]
let days4567 = days[4...]
// Before Swift 4: days[days.startIndex..< 4]
let days123 = days[..<4]

print(days4567)
print(days123)

var numDays = Array(zip(1..., days))
print(numDays)

// Part 2
var current = 1
while current*current*current <= 10000 {
    current += 1
}
let result = current*current*current
print(result)

let r = (1...)
   .lazy
   .map { $0 * $0 * $0 }
   .first(where: { $0 > 10000})
print(r!)

let rs = (1...)
   .lazy
   .map { $0 * $0 * $0 }
   .filter { $0 > 10000 }

let r10 = Array(rs.prefix(10))
print(r10)

// Part 3
func Day(dayNum: Int) {
	switch dayNum {
		// 1 or 2
	case ...2:
		print("Too early for weekend")
	case 3...5:
		print("Getting there")
		// 6 or 7
	case 6...7:
		print("Enjoy your weekend!")
	case 8...:
		print("Wrong value!")
	default:
		print("Should not get there!")
	}
}

Day(dayNum: 1)
Day(dayNum: 6)
Day(dayNum: 8)